#ifndef NWT_MOTORS_H
#define NWT_MOTORS_H

#include "XMC1100.h"
#include "..\_Driver\GPIO.h"

#define FORWARD 			1
#define BACKWARD 			0

#define TICK_DEG 			50
#define WHEEL_CIRC		16
#define ROB_TURN_CIRC	31

//Hier die Ports veraendern
__STATIC_INLINE void RMotor_setMode(uint8_t mode) {
	//evtl. enable_digital
	P0_5_set_mode(mode);
}

__STATIC_INLINE void RMotor_set(void) {
	P0_5_set();
}

__STATIC_INLINE void RMotor_reset(void) {
	P0_5_reset();
}

__STATIC_INLINE void LMotor_setMode(uint8_t mode) {
	//evtl. enable_digital
	P0_0_set_mode(mode);
}

__STATIC_INLINE void LMotor_set(void) {
	P0_0_set();
}

__STATIC_INLINE void LMotor_reset(void) {
	P0_0_reset();
}

__STATIC_INLINE void ROdo_Init(void) {
	//evtl. enable digital
	P0_9_set_mode(INPUT_PU);
}

__STATIC_INLINE uint32_t ROdo_Read(void) {
	return P0_9_read();
}

__STATIC_INLINE void LOdo_Init(void) {
	//evtl. enable digital
	P0_8_set_mode(INPUT);
}

__STATIC_INLINE uint32_t LOdo_Read(void) {
	return P0_8_read();
}

extern uint8_t rMotorDirection, rMotorSpeed;

void RMotor_init(void);
void RMotor_setDirection(uint8_t direction);
void RMotor_setSpeed(uint8_t speed);
void RMotor_drive(void);
void RMotor_brake(void);
void RMotor_coast(void);

extern uint8_t lMotorDirection, lMotorSpeed;

void LMotor_init(void);
void LMotor_setDirection(uint8_t direction);
void LMotor_setSpeed(uint8_t speed);
void LMotor_drive(void);
void LMotor_brake(void);
void LMotor_coast(void);

extern uint8_t lWheelTick, rWheelTick;
extern int32_t lWheelDeg, rWheelDeg;
extern int32_t robotDeg;

void Odo_Init(void);
void Odo_Update(void);
int32_t LOdo_getDeg(void);
int32_t ROdo_getDeg(void);
int32_t Odo_getRobDeg(void);

#endif
